# Exerciții DNS

Pornind de la codul disponibil
[aici](https://gitlab.cs.pub.ro/pcom/pcom-laboratoare-public/-/tree/master/lab10/Dns),
implementați următoatrea cerință:

1\. Scrieți un program care să afișeze numele și adresele IP pentru un
host. Programul poate primi ca parametru fie numele (caz în care se va
afișa adresa), fie adresa IP (caz în care se va afișa numele).

Exemple de apel: 
```
./dns -n google.com
./dns -a 8.8.8.8
```

Testați-va programul comparând rezultatele cu cele oferite de **nslookup** sau **host**.

2\. Folosind utilitarul *dig*, realizați următoarele sarcini:

 - realizați cereri de adresă (A) pentru fiecare gazdă din tabelul de mai jos
 - pentru a afla serverul de mail pentru domeniul din tabel, realizați o cerere de tip MX

<table>
	<tbody>
		<tr>
			<th>Tip&nbsp;</th>
			<th>Gazdă&nbsp;</th>
			<th>Răspuns&nbsp;</th>
			<th>TTL&nbsp;</th>
			<th>Prioritate&nbsp;</th>
		</tr>
		<tr>
			<td colspan="5" style="text-align:center"><strong>Pentru single-v4 există o singură adresă IPv4</strong></td>
		</tr>
		<tr>
			<td>A&nbsp;</td>
			<td>single-v4.protocoale.space&nbsp;</td>
			<td>127.0.0.1&nbsp;</td>
			<td>600&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td colspan="5" style="text-align:center"><strong>Pentru single-v4 există o singură adresă IPv6</strong></td>
		</tr>
		<tr>
			<td>AAAA&nbsp;</td>
			<td>single-v6.protocoale.space&nbsp;</td>
			<td>::1&nbsp;</td>
			<td>600&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td colspan="5" style="text-align:center"><strong>Pentru single se definesc 2 adrese (una IPv4 si una IPv6)</strong></td>
		</tr>
		<tr>
			<td>A&nbsp;</td>
			<td>single.protocoale.space&nbsp;</td>
			<td>127.0.0.1&nbsp;</td>
			<td>600&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td>AAAA&nbsp;</td>
			<td>single.protocoale.space&nbsp;</td>
			<td>::1&nbsp;</td>
			<td>600&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td colspan="5" style="text-align:center"><strong>Spațiul dorinel.protocoale.space este delegat către alte server de nume ce rulează la adresele {ns1,ns2,ns3,ns4,ns5}.he.net</strong></td>
		</tr>
		<tr>
			<td>NS&nbsp;</td>
			<td>dorinel.protocoale.space&nbsp;</td>
			<td>ns1.he.net&nbsp;</td>
			<td>600&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td>NS&nbsp;</td>
			<td>dorinel.protocoale.space&nbsp;</td>
			<td>ns2.he.net&nbsp;</td>
			<td>600&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td>NS&nbsp;</td>
			<td>dorinel.protocoale.space&nbsp;</td>
			<td>ns3.he.net&nbsp;</td>
			<td>600&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td>NS&nbsp;</td>
			<td>dorinel.protocoale.space&nbsp;</td>
			<td>ns4.he.net&nbsp;</td>
			<td>600&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td>NS&nbsp;</td>
			<td>dorinel.protocoale.space&nbsp;</td>
			<td>ns5.he.net&nbsp;</td>
			<td>600&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td colspan="5" style="text-align:center"><strong>Pentru multi-v4 există 4 adrese IPv4</strong></td>
		</tr>
		<tr>
			<td>A&nbsp;</td>
			<td>multi-v4.protocoale.space&nbsp;</td>
			<td>127.1.1.1&nbsp;</td>
			<td>600&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td>A&nbsp;</td>
			<td>multi-v4.protocoale.space&nbsp;</td>
			<td>127.2.2.2&nbsp;</td>
			<td>600&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td>A&nbsp;</td>
			<td>multi-v4.protocoale.space&nbsp;</td>
			<td>127.3.3.3&nbsp;</td>
			<td>600&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td>A&nbsp;</td>
			<td>multi-v4.protocoale.space&nbsp;</td>
			<td>127.4.4.4&nbsp;</td>
			<td>600&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td colspan="5" style="text-align:center"><strong>Pentru multi-v6 există 4 adrese IPv6</strong></td>
		</tr>
		<tr>
			<td>AAAA&nbsp;</td>
			<td>multi-v6.protocoale.space&nbsp;</td>
			<td>::1&nbsp;</td>
			<td>600&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td>AAAA&nbsp;</td>
			<td>multi-v6.protocoale.space&nbsp;</td>
			<td>::2&nbsp;</td>
			<td>600&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td>AAAA&nbsp;</td>
			<td>multi-v6.protocoale.space&nbsp;</td>
			<td>::3&nbsp;</td>
			<td>600&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td>AAAA&nbsp;</td>
			<td>multi-v6.protocoale.space&nbsp;</td>
			<td>::4&nbsp;</td>
			<td>600&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td colspan="5" style="text-align:center"><strong>Pentru multi se definesc 8 adrese (4 de IPv4 și 4 de IPv6)</strong></td>
		</tr>
		<tr>
			<td>A&nbsp;</td>
			<td>multi.protocoale.space&nbsp;</td>
			<td>127.1.1.1&nbsp;</td>
			<td>600&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td>A&nbsp;</td>
			<td>multi.protocoale.space&nbsp;</td>
			<td>127.2.2.2&nbsp;</td>
			<td>600&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td>A&nbsp;</td>
			<td>multi.protocoale.space&nbsp;</td>
			<td>127.3.3.3&nbsp;</td>
			<td>600&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td>A&nbsp;</td>
			<td>multi.protocoale.space&nbsp;</td>
			<td>127.4.4.4&nbsp;</td>
			<td>600&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td>AAAA&nbsp;</td>
			<td>multi.protocoale.space&nbsp;</td>
			<td>::1&nbsp;</td>
			<td>600&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td>AAAA&nbsp;</td>
			<td>multi.protocoale.space&nbsp;</td>
			<td>::2&nbsp;</td>
			<td>600&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td>AAAA&nbsp;</td>
			<td>multi.protocoale.space&nbsp;</td>
			<td>::3&nbsp;</td>
			<td>600&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td>AAAA&nbsp;</td>
			<td>multi.protocoale.space&nbsp;</td>
			<td>::4&nbsp;</td>
			<td>600&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td colspan="5" style="text-align:center"><strong>Adresele pc&rarr;pcom&rarr;protocoale definesc un șir de nume canonice care are la capăt o adresă IPv4</strong></td>
		</tr>
		<tr>
			<td>CNAME&nbsp;</td>
			<td>pc.protocoale.space&nbsp;</td>
			<td>pcom.protocoale.space&nbsp;</td>
			<td>600&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td>CNAME&nbsp;</td>
			<td>pcom.protocoale.space&nbsp;</td>
			<td>protocoale.protocoale.space&nbsp;</td>
			<td>600&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td>A&nbsp;</td>
			<td>protocoale.protocoale.space&nbsp;</td>
			<td>127.42.42.42&nbsp;</td>
			<td>600&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td colspan="5" style="text-align:center"><strong>Emailul este deservit de 3 servere SMTP cu priorități diferite</strong></td>
		</tr>
		<tr>
			<td>MX&nbsp;</td>
			<td>protocoale.space&nbsp;</td>
			<td>alt1.gmail-smtp-in.l.google.com&nbsp;</td>
			<td>600&nbsp;</td>
			<td>10&nbsp;</td>
		</tr>
		<tr>
			<td>MX&nbsp;</td>
			<td>protocoale.space&nbsp;</td>
			<td>alt2.gmail-smtp-in.l.google.com&nbsp;</td>
			<td>600&nbsp;</td>
			<td>20&nbsp;</td>
		</tr>
		<tr>
			<td>MX&nbsp;</td>
			<td>protocoale.space&nbsp;</td>
			<td>alt3.gmail-smtp-in.l.google.com&nbsp;</td>
			<td>600&nbsp;</td>
			<td>30&nbsp;</td>
		</tr>
		<tr>
			<th>Tip&nbsp;</th>
			<th>Gazdă&nbsp;</th>
			<th>Răspuns&nbsp;</th>
			<th>TTL&nbsp;</th>
			<th>Prioritate</th>
		</tr>
	</tbody>
</table>
