# Ethernet

Ethernet este echivalentul protocolului de DataLink pe care l-am implementat în
primele laboratoare. Noi vom lucra doar cu **cadre Ethernet** ce sunt transmise
ca payload peste implementarea protocolului de nivel fizic Ethernet. Cum CRC-ul
este calculat în hardware, nu o să îl regăsim în header. În acest caz, header-ul
pe care îl vom folosi este următorul:

```
Ethernet Frame
    +-----------------+------------+-------------+
    |     Bytes 0-5   | Bytes 6-11 | Bytes 12-13 |
    +------------------------------+-------------+
    | Destination MAC | Source MAC |  EtherType  |
    +-----------------+------------+-------------+
```
Adresa MAC Destinație reprezintă identificatorul dispozitivului de nivel 2 către
care a fost trimis acest cadru.

În cadrul laboratorului puteți folosi următoarea structura pentru un
cadru Ethernet. Pentru câmpul EtherType ne interesează doar valoarea
`ETHERTYPE_IP` (0x0800).

``` C
struct  ether_header {
    uint8_t  ether_dhost[6];
    uint8_t  ether_shost[6];
    uint16_t ether_type;     // ETHERTYPE_IP
};
```

