# Porturi

Porturile sunt conceptul ce ne ajută să facem **multiplexare** între aplicații.

În contextul rețelelor de comunicație, un port este un număr asociat unui socket dintr-un
proces (nu unui host). Dacă un proces dorește să comunice cu alte procese,
aceasta expune un port, o locație logică prin care accepta conexiuni sau
prin care se realizează schimbul de date.

Aceste numere permit aplicațiilor să partajeze concurent resursele de
rețea. Serverul de mail, de exemplu, nu așteapta terminarea altor procese ce implica
reteaua (ex. web surfing) pentru a putea trimite un mail la destinație.

În antetul protocoalelor de nivel transport, portul este 
reprezentat pe 2 bytes: `uint16_t port;`. 

![](images/port.md)

> Mai multe porturi au fost rezervate în procesul de standardizare. Astfel, în
[RFC 1340](https://www.rfc-editor.org/rfc/rfc1340#page-9) gasiți o listă de
porturi care sunt considerate ca fiind rezervate (sau **well-known**) pentru anumite protocoale. De
exemplu, portul 21 este rezervat pentru `File Transfer Protocol` (FTP).
